

// line 5 "SimpleMarkovChain.jweb"
/* $Header: /cvsroot/hydra-mcmc/Hydra/org/omegahat/Simulation/MCMC/Examples/SimpleMarkovChain.java,v 1.1.1.1 2001/04/04 17:16:19 warneg Exp $  */
/* (c) 1999 by the Omegahat Project */


// line 99 "SimpleMarkovChain.jweb"
    package org.omegahat.Simulation.MCMC.Examples;


// line 105 "SimpleMarkovChain.jweb"
    import org.omegahat.Simulation.MCMC.*;
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;
    import org.omegahat.Simulation.MCMC.Expressions.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;
    import org.omegahat.Probability.Distributions.*;
    import org.omegahat.Simulation.RandomGenerators.*;



// line 20 "SimpleMarkovChain.jweb"
/**
 * A simple Markov Chain example. It simply generates
 * its next state from N(0,1) regardless of the current state.
 */
public class SimpleMarkovChain extends BaseMarkovChain
{
    
// line 34 "SimpleMarkovChain.jweb"
    protected PRNG                prng;
    protected Normal              norm;

    protected class doubleState implements MCMCState
    {
        double state;
        public double getState() { return state; }
        public doubleState( double d ) { state = d; }
        public String toString() { return ""+state; }
    }

// line 27 "SimpleMarkovChain.jweb"
    
// line 49 "SimpleMarkovChain.jweb"
    public MCMCState generate( MCMCState ignored )
    {
        return new doubleState(norm.generateDouble());
    }

    public SimpleMarkovChain( PRNG prng )
    {
        this.prng = prng;
        this.norm = new Normal ( prng );
    }


// line 28 "SimpleMarkovChain.jweb"
    


// line 67 "SimpleMarkovChain.jweb"
    public static class listenerPrinter implements MCMCListener
    {
	public int step=0;
	public void notify( MCMCEvent e ){
	    if( e instanceof GenericChainStepEvent )
		{
		    step++;
		    System.out.println("** Notify : Chain Step Event #" + step + " ** ");
		}
	    else
		System.out.println("** Notify: Unrecognized Event ** ");
	    System.out.println("** Details:");
	    System.out.println( e );
	}
    }


    public static void main( String[] argv )
    {
        PRNG prng = new CollingsPRNG( (new CollingsPRNGAdministrator()).registerPRNGState() );

        BaseMarkovChain chain = new SimpleMarkovChain(prng);
	chain.registerListener( new listenerPrinter() );

        chain.iterate(10);
        System.err.println( chain.getState() );
    }

// line 29 "SimpleMarkovChain.jweb"
}
