package org.omegahat.Simulation.RandomGenerators;


/**
 * Pseudo-random variable generators for univariate variables representable by double's.
 */
public interface PseudoRandomUnivariateGenerator
  extends PseudoRandomVariableGenerator 
{
    /** 
     * Generate a single pseudo-random value.
     */
    public double    nextDouble( );     /* synchronized*/ 
    
    /** 
     * Generate several pseudo-random values.
     * @param n number of double values to return
     * @retval an array of <b>n</b> doubles's.
     */
    public double[ ] nextDouble(int n); /* synchronized*/ 
}

